--
-- This function is used to fill table with large values
-- avg of index which should be used to do index scan without
-- seq scan (we don't use seq scan to skip usage of BufferAccessStartegy)
-- is 1000000000 + 1000 / 2 + 20 = 1000000520
-- We keep number of records small to don't overwrite index form
-- testCase2 tables
-- We ask for 480 * 400000 ~ 19.2MB of data
CREATE OR REPLACE FUNCTION createTestCase1()
  RETURNS void AS
$BODY$
declare
	i int8;
	max int8;
	idx varchar(100);
	txt varchar(2000);
	num varchar(10);
begin
	i = 1000000000;
	max = i + 100000;
	--max = i + 2;
	loop
		exit when i > max;
		num = i::text;
		idx = '';
		txt = '';
		for j in 1..10 loop
		  idx = rpad(idx, 10*j, substr(num, j, 1));
		  txt = rpad(idx, 200*j, substr(num, j, 1));
		end loop;

		insert into testCase1 values(i - 1000000000, txt);

		i = i + 1;
	end loop;

end
$BODY$
  LANGUAGE plpgsql;

--
-- This function is used to fill table which index should be prevented
-- from clock sweep.
-- Avg of index is 1000000000 + 400000/2 + 2000 = 1000202000
-- This value should trigger usage of index
-- The content is small to don't stuck in reading values
CREATE OR REPLACE FUNCTION createTestCase2()
  RETURNS void AS
$BODY$
declare
	i int8;
	max int8;
begin
	i = 1000000000;
	max = i + 400000;
	--max = i + 2;
	loop
		exit when i > max;
		insert into testCase2 values(i, '');
		i = i + 1;
	end loop;

end
$BODY$
  LANGUAGE plpgsql;

-- This function is used to do query on table testCase1
-- we use perform to don't include in timings time of
-- result set transmision and simillar stuff
CREATE OR REPLACE FUNCTION executeBufferOverwrite()
  RETURNS void AS
$BODY$
begin
    PERFORM substr(content, 1, 1) FROM testcase1 WHERE multi_id > 50000 + 10;
end
$BODY$
  LANGUAGE plpgsql;

-- Execute short query which should use index on testCase1
-- We ask only for few records from end of index to don't stuck in reading 
-- values
CREATE OR REPLACE FUNCTION executeIndexQuery()
  RETURNS void AS
$BODY$
declare
    i int4;
begin
    i = 1000000000 + 400000/2 + 2000;
    --i = 1000000000 + 400000 - 1;
    PERFORM '' FROM testcase2 WHERE multi_id > i;
end
$BODY$
  LANGUAGE plpgsql;
