#!/bin/bash

BASEDIR=$(dirname $0)

source $BASEDIR/setenv.sh

sh $BASEDIR/do_init.sh

echo "Relations statistics:"
${PSQL_FULL} < "$BASEDIR/04_dump_usage_statistics.sql"

echo "Executing index query to cache index"
${PSQL_FULL} < "$BASEDIR/05_do_tests_part_index_query.sql" >> /dev/null 2>&1

echo "Executing index query to collect statistics"
${PSQL_FULL} < "$BASEDIR/05_do_tests_part_index_query.sql"

echo "Executing buffer overfull query"
${PSQL_FULL} < "$BASEDIR/05_do_tests_buffer_full.sql"

echo "Trying to drop system caches to emphasise results..."
echo "(this may fail if you are not root user)"
echo "This is required to emphasise and show situation when reading overwrited"
echo "system buffers, too. Actually no drop buffers gives almost no difference"
echo "because memory copy of 545*8192 bytes is short."
echo "3 > /proc/sys/vm/drop_caches ..."

echo 3 > /proc/sys/vm/drop_caches

echo "Executing index query to collect statistics, after full overfull"
${PSQL_FULL} < "$BASEDIR/05_do_tests_part_index_query.sql"